[tox]
envlist = coverage-clean,{py27,pypy,py35,py36,py37,pypy3}-{twlatest,twtrunk,twlowest}-{aclatest,acmaster}-alldeps,py27-twlatest,flake8,docs,coverage-report

[testenv]
setenv =
    PYTHONWARNINGS = default::DeprecationWarning
    HYPOTHESIS_PROFILE = coverage
whitelist_externals =
    mkdir
deps =
    .[test]
    alldeps: .[libcloud]
    acmaster: https://github.com/certbot/certbot/archive/master.zip#egg=acme&subdirectory=acme
    twlatest: Twisted[tls]
    twtrunk: https://github.com/twisted/twisted/archive/trunk.zip#egg=Twisted[tls]
    twlowest: Twisted[tls]==16.2.0
    coverage
commands =
    pip list
    mkdir -p {envtmpdir}
    coverage run --parallel-mode \
        {envdir}/bin/trial --temp-directory={envtmpdir}/_trial_temp {posargs:txacme integration}

[testenv:flake8]
basepython = python3.6
deps =
    flake8
    pep8-naming
commands = flake8 src setup.py

[testenv:coverage-clean]
deps = coverage
skip_install = true
commands = coverage erase

[testenv:coverage-report]
deps =
    coverage
    diff_cover
skip_install = true
commands =
    coverage combine
    coverage report
    coverage xml -o {envtmpdir}/coverage.xml
    diff-cover {envtmpdir}/coverage.xml

[testenv:docs]
whitelist_externals =
    rm
    test
    cat
changedir = docs
deps =
    -rrequirements-doc.txt
commands =
    rm -rf {toxinidir}/docs/api/
    rm -f {envtmpdir}/errors
    sphinx-build -W -w {envtmpdir}/errors --keep-going \
        -n -b html -d {envtmpdir}/doctrees . {envtmpdir}/html
    cat {envtmpdir}/errors
    test ! -s {envtmpdir}/errors
